/**
 * @param { import("knex").Knex } knex
 * @returns { Promise<void> }
 */
exports.up = function(knex) {
  return knex.schema
    .createTable('counterConfigurations', table => {
      table.string('counter').references('key').inTable('counters').onDelete('CASCADE');
      table.string('guild').notNullable();
      table.string('configName').notNullable();
      table.string('value').nullable();
    });
};

/**
 * @param { import("knex").Knex } knex
 * @returns { Promise<void> }
 */
exports.down = function(knex) {
  return knex.schema
    .dropTable('counterConfigurations');
};
