/**
 * @param { import("knex").Knex } knex
 * @returns { Promise<void> }
 */
exports.up = function(knex) {
  return knex.schema
    .createTable('sessions', table => {
      table.string('id').notNullable();
      table.string('tokenType').notNullable();
      table.string('accessToken').notNullable();
      table.string('refreshToken').notNullable();
      table.timestamp('expiresAt').notNullable();
    });
};

/**
 * @param { import("knex").Knex } knex
 * @returns { Promise<void> }
 */
exports.down = function(knex) {
  return knex.schema
    .dropTable('sessions');
};
