import { Collection, SlashCommandBuilder, CommandInteraction, Client } from 'discord.js';
import { Autocomplete } from '../lib/autocomplete';

export interface Command {
  data: Pick<SlashCommandBuilder, 'toJSON' | 'name'>,
  execute: (interaction: CommandInteraction) => Promise<unknown>,
  autocomplete?: Autocomplete,
  onClientReady?: (client: Client) => Promise<unknown>,
  serverWhitelist?: string[],
}

export interface Config {
  token: string,
  sitePort: number, 
  siteURL: string,
  clientId: string,
  clientSecret: string,
}

declare module 'discord.js' {
  export interface Client {
    config: Config,
    commands: Collection<string, Command>;
  }
}